   10T$="PLAN13": REM  OSCAR-13 POSITION, SUN + ECLIPSE PLANNER
   20REM
   30IS$="v2.0": REM Last mod 1992 Jan 14 by JRM
   40REM
   50REM        (C)1992 J.R. Miller G3RUH
   60REM
   70REM Proceeds from the sale of this software go directly to the
   80REM Amateur Satellite Programme that helped fund AO-13.
   90REM If you take a copy PLEASE also send a small donation to:
  100REM         AMSAT-UK, LONDON, E12 5EQ.
  110*TV255,1
  120MODE 3:   REM Screen 80 columns
  130PROCinit: REM Set up constants
  140
  150INPUT "Enter start date (e.g. 1992, 12, 25) ";YR,MN,DY
  160INPUT "Enter number of days for printout    ";ND
  170DS = FNday(YR,MN,DY):  REM Start  day No.
  180DF = DS + ND - 1:      REM Finish day No.
  190FOR DN = DS TO DF
  200FOR HR  = 0 TO 23
  210FOR MIN = 0 TO 45 STEP 15
  220TN = (HR+MIN/60)/24
  230PROCsatvec
  240PROCrangevec
  250PROCsunvec
  260IF EL > 0 THEN PROCprintdata
  270NEXT:NEXT:NEXT:VDU3
  280END
  290
 1000DEF PROCinit
 1010REM SATELLITE EPHEMERIS
 1020REM -------------------
 1030SAT$="OSCAR-13"
 1040YE = 1991      :REM Epoch Year   year
 1050TE = 333.495944:REM Epoch time   days
 1060IN =  56.6997  :REM Inclination  deg
 1070RA =  57.8816  :REM R.A.A.N.     deg
 1080EC = 0.7263    :REM Eccentricity  -
 1090WP = 271.2387  :REM Arg perigee  deg
 1100MA =  14.3421  :REM Mean anomaly deg
 1110MM = 2.097020  :REM Mean motion  rev/d
 1120M2 = 1E-9      :REM Decay Rate   rev/d/d
 1130RV = 2649      :REM Orbit number  -
 1140ALON = 180     :REM Sat attitude deg. 180 = nominal ) See bulletins
 1150ALAT =   0     :REM Sat attitude deg.   0 = nominal ) for latest
 1160
 1170REM Observer's location + North, + East, ASL(m)
 1180LOC$="G3RUH": LA = 52.21: LO = 0.06: HT = 79:  REM Cambridge, UK
 1190
 1200LA = RAD(LA): LO = RAD(LO): HT = HT/1000
 1210CL = COS(LA): SL = SIN(LA): CO = COS(LO): SO = SIN(LO)
 1220RE = 6378.140: FL = 1/298.257:     REM IAU-76 Earth ellipsoid
 1230RP = RE*(1-FL): XX = RE*RE: ZZ = RP*RP
 1240D  = SQR(XX*CL*CL + ZZ*SL*SL)
 1250Rx = XX/D + HT: Rz = ZZ/D + HT
 1260
 1270REM Observer's unit vectors UP EAST and NORTH in GEOCENTRIC coords.
 1280Ux =CL*CO: Ex =-SO: Nx =-SL*CO
 1290Uy =CL*SO: Ey = CO: Ny =-SL*SO
 1300Uz =SL   : Ez =  0: Nz = CL
 1310
 1320REM Observer's XYZ coords at Earth's surface
 1330Ox = Rx*Ux: Oy = Rx*Uy: Oz = Rz*Uz
 1340
 1350REM Convert angles to radians etc.
 1360RA = RAD(RA): IN = RAD(IN): WP = RAD(WP)
 1370MA = RAD(MA): MM = MM*2*PI: M2 = M2*2*PI
 1380
 1390YM = 365.25:     REM Mean Year,     days
 1400YT = 365.2421970:REM Tropical year, days
 1410WW = 2*PI/YT:    REM Earth's rotation rate, rads/whole day
 1420WE = 2*PI + WW:  REM  ditto  rads/day
 1430W0 = WE/86400:   REM  ditto  rads/sec
 1440
 1450VOx=-Oy*W0: VOy=Ox*W0: REM Observer's velocity, GEOCENTRIC coords. (VOz=0)
 1460
 1470REM Convert satellite Epoch to Day No. and Fraction of day
 1480DE = FNday(YE,1,0)+INT(TE): TE = TE-INT(TE)
 1490
 1500REM Average Precession rates
 1510GM = 3.986E5:    REM Earth's Gravitational constant km^3/s^2
 1520J2 = 1.08263E-3: REM 2nd Zonal coeff, Earth's Gravity Field
 1530N0 = MM/86400:   REM Mean motion rad/s
 1540A0 = EXP(LN(GM/N0/N0)/3): REM Semi major axis km
 1550B0 = A0*SQR(1-EC*EC)
 1560SI = SIN(IN): CI = COS(IN)
 1570PC = RE*A0/(B0*B0): PC = 1.5*J2*PC*PC*MM: REM Precession const, rad/Day
 1580QD = -PC*CI:            REM Node precession rate, rad/day
 1590WD =  PC*(5*CI*CI-1)/2: REM Perigee precession rate, rad/day
 1600DC = -2*M2/MM/3: REM Drag coeff. (Angular momentum rate)/(Ang mom)  s^-1
 1610
 1620REM Sidereal and Solar data. NEVER needs changing. Valid to year 2000+
 1630YG = 1990: G0 = 99.4033:  REM GHAA, Year YG, Jan 0.0
 1640MAS0 = 356.6349: MASD = 0.98560027: REM MA Sun and rate, deg, deg/day
 1650INS = RAD(23.4406): CNS = COS(INS): SNS = SIN(INS): REM Sun's inclination
 1660EQC1=0.03343: EQC2=0.00034:   REM Sun's Equation of centre terms
 1670
 1680REM Bring Sun data to Satellite Epoch
 1690TEG  = (DE-FNday(YG,1,0)) + TE: REM Elapsed Time: Epoch - YG
 1700GHAE = RAD(G0) + TEG*WE:        REM GHA Aries, epoch
 1710MRSE = RAD(G0) + TEG*WW + PI:   REM Mean RA Sun at Sat epoch
 1720MASE = RAD(MAS0 + MASD*TEG):    REM Mean MA Sun  ..
 1730
 1740REM Antenna unit vector in orbit plane coordinates.
 1750CO=COS(RAD(ALON)): SO=SIN(RAD(ALON))
 1760CL=COS(RAD(ALAT)): SL=SIN(RAD(ALAT))
 1770ax = -CL*CO: ay = -CL*SO: az = -SL
 1780
 1790REM Misc
 1800@%=&507: REM 5 decimals, field 7
 1810OLDRN=-99999
 1820PRINT T$;" ";IS$;"   SATELLITE PREDICTIONS"
 1830PRINT STRING$(35,"-")
 1840ENDPROC
 1850
 2000DEF PROCsatvec
 2010REM Calculate Satellite Position at DN,TN
 2020T  = (DN - DE) + (TN-TE):REM Elapsed T since epoch, days
 2030DT = DC*T/2: KD = 1+4*DT:KDP= 1-7*DT: REM Linear drag terms
 2040M  = MA + MM*T*(1-3*DT): REM Mean anomaly at YR,TN
 2050DR = INT(M/(2*PI)):      REM Strip out whole no of revs
 2060M  = M - DR*2*PI:        REM M now in range 0 - 2pi
 2070RN = RV + DR:            REM Current Orbit number
 2080
 2090REM Solve M = EA - EC*SIN(EA) for EA given M, by Newton's Method
 2100EA = M:               REM Initial solution
 2110REPEAT
 2120C = COS(EA): S = SIN(EA): DNOM=1-EC*C
 2130D = (EA-EC*S-M)/DNOM: REM Change to EA for better solution
 2140EA = EA - D:          REM by this amount
 2150UNTIL ABS(D) < 1E-5:  REM Until converged
 2160
 2170A = A0*KD: B = B0*KD: RS = A*DNOM: REM Distances
 2180
 2190REM Calc satellite position & velocity in plane of ellipse
 2200Sx = A*(C-EC): Vx=-A*S/DNOM*N0
 2210Sy = B*S:      Vy= B*C/DNOM*N0
 2220
 2230AP   = WP + WD*T*KDP: CW = COS(AP):   SW = SIN(AP)
 2240RAAN = RA + QD*T*KDP: CQ = COS(RAAN): SQ = SIN(RAAN)
 2250
 2260REM Plane -> celestial coordinate transformation, [C] = [RAAN]*[IN]*[AP]
 2270CXx=CW*CQ-SW*CI*SQ: CXy=-SW*CQ-CW*CI*SQ: CXz= SI*SQ
 2280CYx=CW*SQ+SW*CI*CQ: CYy=-SW*SQ+CW*CI*CQ: CYz=-SI*CQ
 2290CZx=SW*SI:          CZy= CW*SI:          CZz= CI
 2300
 2310REM Compute SATellite's position vector, ANTenna axis unit vector
 2320REM and VELocity in CELESTIAL coordinates. (Note: Sz=0, Vz=0)
 2330SATx=Sx*CXx+Sy*CXy: ANTx=ax*CXx+ay*CXy+az*CXz: VELx=Vx*CXx+Vy*CXy
 2340SATy=Sx*CYx+Sy*CYy: ANTy=ax*CYx+ay*CYy+az*CYz: VELy=Vx*CYx+Vy*CYy
 2350SATz=Sx*CZx+Sy*CZy: ANTz=ax*CZx+ay*CZy+az*CZz: VELz=Vx*CZx+Vy*CZy
 2360
 2370REM Also express SAT,ANT and VEL in GEOCENTRIC coordinates:
 2380GHAA = GHAE + WE*T:           REM GHA Aries at elapsed time T
 2390C = COS(-GHAA): S = SIN(-GHAA)
 2400Sx=SATx*C - SATy*S: Ax=ANTx*C - ANTy*S: Vx=VELx*C - VELy*S
 2410Sy=SATx*S + SATy*C: Ay=ANTx*S + ANTy*C: Vy=VELx*S + VELy*C
 2420Sz=SATz:            Az=ANTz:            Vz=VELz
 2430ENDPROC
 2440
 3000DEF PROCsunvec
 3010MAS = MASE + RAD(MASD*T):       REM MA of Sun round its orbit
 3020TAS = MRSE + WW*T + EQC1*SIN(MAS) + EQC2*SIN(2*MAS)
 3030C = COS(TAS): S=SIN(TAS):       REM Sin/Cos Sun's true anomaly
 3040SUNx=C: SUNy=S*CNS: SUNz=S*SNS: REM Sun unit vector - CELESTIAL coords
 3050
 3060REM Find Solar angle, illumination, and eclipse status.
 3070SSA = -(ANTx*SUNx + ANTy*SUNy + ANTz*SUNz):REM Sin of Sun angle -a.h
 3080ILL = SQR(1-SSA*SSA):                      REM Illumination
 3090CUA = -(SATx*SUNx+SATy*SUNy+SATz*SUNz)/RS: REM Cos of umbral angle -h.s
 3100UMD = RS*SQR(1-CUA*CUA)/RE:                REM Umbral dist, Earth radii
 3110IF CUA>=0 THEN ECL$="    +" ELSE ECL$="    -": REM + for shadow side
 3120IF UMD <= 1 AND CUA>=0 THEN ECL$="   ECL":     REM - for sunny side
 3130
 3140REM Obtain SUN unit vector in GEOCENTRIC coordinates
 3150C = COS(-GHAA): S = SIN(-GHAA)
 3160Hx=SUNx*C - SUNy*S
 3170Hy=SUNx*S + SUNy*C
 3180Hz=SUNz:  REM satellite possibly visible
 3190IF (Hx*Ux+Hy*Uy+Hz*Uz < -0.17) AND (ECL$ <> "   ECL") THEN ECL$="   vis"
 3200
 3210REM Obtain Sun unit vector in ORBIT coordinates
 3220Hx =SUNx*CXx+SUNy*CYx+SUNz*CZx
 3230Hy =SUNx*CXy+SUNy*CYy+SUNz*CZy
 3240Hz =SUNx*CXz+SUNy*CYz+SUNz*CZz
 3250SEL=ASN(Hz): SAZ= FNatn(Hy,Hx)
 3260ENDPROC
 3270
 4000DEF PROCrangevec
 4010REM Compute and manipulate range/velocity/antenna vectors
 4020Rx = Sx-Ox: Ry = Sy-Oy: Rz = Sz-Oz: REM Rangevec = Satvec - Obsvec
 4030R = SQR(Rx*Rx+Ry*Ry+Rz*Rz):         REM Range magnitude
 4040Rx=Rx/R: Ry=Ry/R: Rz=Rz/R:REM Normalise Range vector
 4050U = Rx*Ux+Ry*Uy+Rz*Uz: REM UP  Component of unit range
 4060E = Rx*Ex+Ry*Ey:       REM EAST   .. (Ez=0)
 4070N = Rx*Nx+Ry*Ny+Rz*Nz: REM NORTH  ..
 4080AZ = DEG(FNatn(E,N)):  REM Azimuth
 4090EL = DEG(ASN(U)):      REM Elevation
 4100
 4110REM Resolve antenna vector along unit range vector, -r.a = Cos(SQ)
 4120SQ = DEG(ACS(-(Ax*Rx + Ay*Ry + Az*Rz))): REM Hi-gain ant SQuint
 4130
 4140REM Calculate sub-satellite Lat/Lon
 4150SLON = DEG(FNatn(Sy,Sx)): REM Lon, + East
 4160SLAT = DEG(ASN(Sz/RS)):   REM Lat, + North
 4170
 4180REM Resolve Sat-Obs velocity vector along unit range vector. (VOz=0)
 4190RR  = (Vx-VOx)*Rx + (Vy-VOy)*Ry + Vz*Rz:  REM Range rate, km/s
 4200ENDPROC
 4210
 4220DEF FNatn(Y,X)
 4230IF X = 0 THEN =PI/2*SGN(Y)
 4240A = ATN(Y/X): IF X < 0 THEN A=A+PI
 4250IF A < 0 THEN =A+2*PI
 4260=A
 4270
 4280DEF PROCmode
 4290M=INT(M*128/PI)
 4300REM Mode switching MA/256
 4310MD$="-"
 4320IF M >=   0 THEN MD$="B"
 4330IF M >= 100 THEN MD$="L"
 4340IF M >= 130 THEN MD$="S"
 4350IF M >= 135 THEN MD$="B"
 4360IF M >= 220 THEN MD$="-"
 4370ENDPROC
 4380
 5000DEF FNdate(D)
 5010REM Day-number to date; valid 1900 Mar 01 - 2100 Feb 28
 5020D=D+428: DW=(D+5)MOD7
 5030Y=INT((D-122.1)/YM): D=D-INT(Y*YM)
 5040MN=INT(D/30.61): D=D-INT(MN*30.6)
 5050MN=MN-1: IF MN>12 THEN MN=MN-12: Y=Y+1
 5060D$=STR$(Y)+" "+MID$("JanFebMarAprMayJunJulAugSepOctNovDec",3*MN-2,3)
 5070=D$+" "+STR$(D)+" ["+MID$("SunMonTueWedThuFriSat",3*DW+1,3)+"]"
 5080
 5090DEF FNday(Y,M,D)
 5100REM Date to day-number
 5110IF M<=2 THEN Y=Y-1: M=M+12
 5120=INT(Y*YM) + INT((M+1)*30.6) + D-428
 5130
 6000DEF PROCprintdata
 6010REM Time as a string
 6020HR$=STR$(HR): MIN$=STR$(MIN)
 6030IF LEN(HR$)  < 2 THEN HR$="0"+HR$
 6040IF LEN(MIN$) < 2 THEN MIN$="0"+MIN$
 6050TIM$=HR$+MIN$+"  "
 6060
 6070PROCmode
 6080R=FNrn(R): EL=FNrn(EL): AZ=FNrn(AZ): SQ=FNrn(SQ): RR=FNrn(RR*10)/10
 6090HGT=FNrn(RS-RE): SLON=FNrn(SLON): SLAT=FNrn(SLAT)
 6100IF RN <> OLDRN THEN OLDRN=RN: PROCheader
 6110PRINT TIM$;STR$(M);"   ";MD$,R,EL,AZ,SQ,RR,ECL$,HGT,SLAT,SLON
 6120ENDPROC
 6130
 6140DEF PROCheader
 6150RAAN=FNrn(DEG(RAAN)): AP=FNrn(DEG(AP)): SAZ=FNrn(DEG(SAZ))
 6160SEL=FNrn(DEG(SEL)): ILL=FNrn(100*ILL)
 6170PRINT: PRINT
 6180PRINT SAT$;"  -  "LOC$;SPC(16);"AMSAT DAY ";STR$(DN-722100);SPC(12);FNdate(DN)
 6190PRINT "ORBIT: ";RN;"   AP/RAAN: ";AP;"/";RAAN;"   ALON/ALAT: ";ALON;"/";ALAT;
 6200PRINT"   SAZ/SEL: ";SAZ;"/";SEL;"   ILL: ";ILL;"%"
 6210PRINT
 6220PRINT " UTC  MA  MODE  RANGE     EL     AZ     SQ     RR  ECL?    ";
 6230PRINT "HGT    SLAT   SLON"
 6240PRINT STRING$(77,"-")
 6250ENDPROC
 6260
 6270DEF FNrn(X) = INT(X+0.5)

